'use strict';

var hoc = require('./hoc');
var parseStatic = require('./parseStatic');
var createMacroComponent = require('./createMacroComponent');

module.exports = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var library = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (config.imports) {
    return createMacroComponent(config, library);
  }

  if (!config.name || !config.type || !config.style) return null;

  var parsed = parseStatic(config);
  var tag = library[parsed.type] || parsed.type;
  var Component = hoc(tag)(parsed, options);

  Component.defaultProps = parsed.props;
  Component.displayName = parsed.name;

  return Component;
};