'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var React = require('react');
var babel = require('babel-standalone');

var parseJSX = function parseJSX(raw) {
  return babel.transform(raw, {
    plugins: [[require('babel-plugin-transform-react-jsx'), {
      useBuiltIns: true
    }]]
  }).code;
};

module.exports = function (config, lib) {
  var name = config.name,
      imports = config.imports,
      jsx = config.jsx;

  try {
    var el = parseJSX(jsx);
    var scope = imports.map(function (key) {
      return lib[key];
    });

    var create = new (Function.prototype.bind.apply(Function, [null].concat(['React'], _toConsumableArray(imports), ['return props => ' + el])))();

    var Comp = create.apply(undefined, [React].concat(_toConsumableArray(scope)));
    Comp.displayName = name;

    return Comp;
  } catch (e) {
    return null;
  }
};