'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Sheet = function Sheet(options) {
  var _this = this;

  _classCallCheck(this, Sheet);

  var _ref = options || {},
      _ref$id = _ref.id,
      id = _ref$id === undefined ? '__DXS__' : _ref$id,
      element = _ref.element;

  this.rules = [];
  this.insert = function (rule) {
    return _this.rules.push(rule);
  };

  this.css = function () {
    return _this.rules.join('\n');
  };

  this.reset = function () {
    _this.rules = [];
    if (_this.sheet) {
      while (_this.sheet.cssRules.length) {
        _this.sheet.deleteRule(0);
      }
    }
  };

  if (typeof document !== 'undefined') {
    this.style = createStyleElement({ id: id, element: element });
    this.sheet = this.style.sheet;

    this.insert = function (rule) {
      _this.rules.push(rule);
      _this.sheet.insertRule(rule, _this.sheet.cssRules.length);
    };
  }
};

var createStyleElement = function createStyleElement(_ref2) {
  var id = _ref2.id,
      element = _ref2.element;

  if (element) {
    document.head.appendChild(element);
    return element;
  }
  var style = document.getElementById(id) || document.head.appendChild(document.createElement('style'));
  style.id = id;
  return style;
};

module.exports = new Sheet();
module.exports.Sheet = Sheet;