'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var h = require('react').createElement;
var PropTypes = require('prop-types');
var blacklist = require('./blacklistedProps');

module.exports = function (Component) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var Styled = function Styled(props) {
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var styleProps = Object.assign({
        theme: context.theme
      }, props);
      var next = {};
      for (var key in props) {
        if (typeof Component === 'string' && blacklist.includes(key)) continue;
        next[key] = props[key];
      }

      next.style = Object.assign.apply(Object, [{}, next.style].concat(_toConsumableArray(args.map(function (arg) {
        return typeof arg === 'function' ? arg(styleProps) : arg;
      }).filter(function (s) {
        return s !== null;
      }))));

      return h(Component, next);
    };

    Styled.contextTypes = {
      theme: PropTypes.oneOfType([PropTypes.object, PropTypes.func])
    };

    return Styled;
  };
};