'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var h = require('react').createElement;
var PropTypes = require('prop-types');
var CSS = require('./CSS');
var blacklistedProps = require('./blacklistedProps');

module.exports = function (Component) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var prefix = options.prefix,
        _options$id = options.id,
        id = _options$id === undefined ? '_dxs' : _options$id;

    var css = new CSS({ prefix: prefix });

    var Styled = function Styled(props) {
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var blacklist = [].concat(_toConsumableArray(Object.keys(Styled.propTypes || {})), _toConsumableArray(blacklistedProps));
      var styleProps = Object.assign({ theme: context.theme || {} }, props);

      var next = {};
      for (var key in props) {
        if (blacklist.includes(key)) continue;
        next[key] = props[key];
      }
      next.className = [next.className].concat(_toConsumableArray(args.map(function (a) {
        return typeof a === 'function' ? a(styleProps) : a;
      }).filter(function (s) {
        return s !== null;
      }).map(function (s) {
        return css(s);
      }))).join(' ').trim();

      return h(Component, next);
    };

    Styled.contextTypes = {
      theme: PropTypes.oneOfType([PropTypes.object, PropTypes.func])
    };

    return Styled;
  };
};